function  normaux = compute_normals(p)

% Compute the normal vectors of the convex hull
% of the points p.
% WARNING : the list is not unique (i.e. some normal
% vectors may be repeated in the output list)
%
% CALL : normals      = compute_normals(points)
%        size(points) = [n 3]


np   = size(p,1);  
dim  = size(p,2);
nmax = 1e6;

if (dim~=3 | np>nmax )
    error('Problem of dimension in compute_normals.m');
end



[K,volume] = convhulln(p);  
A          = p(K(:,1),:);
B          = p(K(:,2),:);
C          = p(K(:,3),:);
AB         = B-A;
AC         = C-A;
normaux    = [(AB(:,2).*AC(:,3)-AB(:,3).*AC(:,2)),(AB(:,3).*AC(:,1)-AB(:,1).*AC(:,3)),(AB(:,1).*AC(:,2)-AB(:,2).*AC(:,1))];
indices    = find(sqrt(sum(normaux.^2,2))>0);
normaux    = normaux(indices,:);
normaux    = normaux./(sqrt(sum(normaux.^2,2))*[1 1 1]);


%normaux    = unique(normaux,'rows');


