#include "mex.h"
#include "qhull_a.h"

/* Variable used by io.c */



/*--------------------------------------------------
-main- derived from call_qhull in user.c

  see program header

  this contains three runs of Qhull for convex hull, Delaunay
  triangulation or Voronoi vertices, and halfspace intersection

*/
void mexFunction(int nOutArray, mxArray *OutArray[], int nInArray,const mxArray *InArray[]){


  int dim;	            /* dimension of points */
  int numpoints;            /* number of points */
 
  boolT ismalloc= False;    /* True if qhull should free points in qh_freeqhull() or reallocation */
  char flags[250];          /* option flags for qhull, see qh_opt.htm */
  FILE *outfile= stdout;    /* output from qh_produce_output()
			       use NULL to skip qh_produce_output() */
  FILE *errfile= stderr;    /* error messages from qhull code */
  int exitcode;             /* 0 if no error from qhull */
  facetT *facet;	    /* set by FORALLfacets */
  int curlong, totlong;	    /* memory remaining after qh_memfreeshort */
  int i,j,k;
  double *V;
  double*   pout1; 
  double*   pout2; 

  outfile = fopen("/dev/null","w");
  int numfacets, numsimplicial, numridges, totneighbors, numcoplanars, numtricoplanars;
  int  num;
  facetT  **facetp;
  vertexT *vertex, **vertexp;
  setT *vertices;
  pointT *point, **pointp, *pointtemp;
  coordT *normp, *coordp, *feasiblep;
  facetT *facetlist;
  boolT zerodiv;
  int format, string, id;
  realT r; 
  int        size_points_intersect; 
  int        compteurr;
  

  /*################################################################################*/
  /* MATLAB STUFF */

  V           = mxGetPr(InArray[0]);
  dim         = mxGetN(InArray[0]);
  numpoints   = mxGetM(InArray[0]);
 
  coordT* points; /* array of coordinates for each point */
  /*coordT *rows[numpoints];*/
  coordT **rows;

  rows=(coordT**)calloc(numpoints,sizeof(coordT*));
  points=(coordT*)calloc((dim+1)*numpoints,sizeof(coordT));



  /*printf("%d %d\n\n",dim,numpoints);*/
  for (k=0; k<dim; k++)  {
    for (j=0; j<numpoints; j++){
      points[k+j*dim] = V[k*numpoints+j];
     }
   } 
 


  /*################################################################################*/
  /* QHULL STUFF */
  /*sprintf (flags, "qhull   %s %s %s", "FS","QJ","Pp");*/
  sprintf (flags, "qhull   %s ", "FS");
  for (i=numpoints; i--; ) rows[i]= points+dim*i;
  
  exitcode= qh_new_qhull (dim, numpoints, points, ismalloc,
                      flags,outfile,errfile); 
  numfacets = qh num_facets;

  fclose(outfile);
  /*printf("Nb faces %d  \n",qh num_facets);*/
  OutArray[0]      = mxCreateDoubleMatrix(1,1, mxREAL);
  OutArray[1]      = mxCreateDoubleMatrix(1,1, mxREAL);

  pout1  = mxGetPr(OutArray[0]);
  pout2  = mxGetPr(OutArray[1]);
  pout1[0] =  qh totvol;
  pout2[0] =  qh totarea;
 
  if (!exitcode) 
    /*   print_summary();*/
  qh_freeqhull (!qh_ALL);
  qh_memfreeshort (&curlong, &totlong);
  if (curlong || totlong)  /* could also check previous runs */
    fprintf (stderr, "qhull internal warning (user_eg, #3): did not free %d bytes of long memory (%d pieces)\n",
       totlong, curlong);

  free(rows);
  free(points);
  return;

  
} /* main */

