function Sp = projection_hyperplan(A,n,p)

% This function project the points p (n*3 or n*2) in
% dimension 3 or 2 onto the plan or the line
% containing the point A and normal 
% to the vector n
%
% CALL : Sp = projection_hyperplan(A,n,p)
%

np   = size(p,1);  
dim  = size(p,2);
n    = n/norm(n);


if (dim<2 | dim>3 | size(A,1)~=1 | size(A,2)~=dim | size(n,1)~=1 | size(n,2)~=dim)
    error('Problem of dimension in projection_hyperplan.m');
end


np    = size(p,1);
AP    = p - ones(np,1)*A;

nn    = ones(np,1)*n;
Sp    = p - sum(AP.*nn,2)*ones(1,dim).*nn;








