function test_inscribe(test,dim)

% Test the inscribe_ball.m function
%
% CALL : test_inscribe(test,dim)
%        test : number of the test case (between 1 and 5)
%        dim  : 2 or 3


m            = 3e2; 
polyedres;
randn('seed',1);

n1           = m;

switch(test)
case 1
  p1           = 2*rand(n1,dim)-1;
case 2
  normaux      = randn(dim,m);
  normaux      = normaux./(ones(dim,1)*(sum(normaux.^2,1).^(0.5)));
  p1           = normaux';
  ac           = 1;
  bc           = 2;
  cc           = 1;
  p1(:,1)      = ac*p1(:,1);
  p1(:,2)      = bc*p1(:,2);   
  if(dim==3)
     p1(:,3)    = cc*p1(:,3);      
  end    
case 3
  dim          = 3;
  p1           = SH;
case 4
  dim          = 3;
  p1           = SI;
case 5
  dim          = 3;
  p1           = SD;
end


normaux      = randn(dim,m);
normaux      = normaux./(ones(dim,1)*(sum(normaux.^2,1).^(0.5)));
p2           = normaux';


[H,K]        = polytope_V2H(p1);
p1           = polytope_H2V(H,K);
[xc,R]       = inscribe_ball(p1,[],[]);
p2           = R*p2+ones(n1,1)*xc';

if(dim==3)
  lighting gouraud
  light
  % Representation graphique
  close all
  hold on

  figure(1)
  set(gcf,'Name',['Chebychev','''','s ball','s of a polytope'])
  hold on

  K1  = convhulln(p1);
  h   = trisurf(K1,p1(:,1),p1(:,2),p1(:,3),ones(size(p1,1),1));
  set(h,'FaceAlpha',0.1);
  set(h,'EdgeColor',[0.3 0.8 .1]);
  set(h,'FaceColor',[0.3 0.7 .1]);set(h,'LineStyle','-');
  set(h,'LineWidth',1); 


  K2  = convhulln(p2);
  h   = trisurf(K2,p2(:,1),p2(:,2),p2(:,3),2*ones(size(p2,1),1));
 
  set(h,'EdgeColor',[0.4 0.4 .4]);
  set(h,'FaceColor',[0.03 0.3 .9]);

  set(h,'FaceAlpha',0.99);
  set(h,'LineStyle','-');


  plot3(xc(1),xc(2),xc(3),'r+');
  axis equal
  axis off
  view([-34 18])
  if(test==2)
    zoom(2)
  end 
else
  
  % Representation graphique
  close all
  hold on

  figure(1)
  set(gcf,'Name',['Chebychev','''','s ball','s of a polytope'])
  hold on
  K1         = convhull(p1(:,1),p1(:,2));
  p1         = p1(K1(1:(length(K1)-1)),:);
  fill(p1(:,1),p1(:,2),1)

  K2           = convhull(p2(:,1),p2(:,2));
  plot(p2(K2,1),p2(K2,2),'b');
  plot(xc(1),xc(2),'r+');
  axis equal
  axis off
end


