function  [volume,surface] = volsurf(p)

% In dimension 3 his function computes the volume and
% the surface of the boundary of a convex body
% described as the convex hull of points p (of dimension n*dim)
% In dimension 2, it computes the area and the length
% of the boundary.
%
% CALL :  [volume,surface] = volsurf(p)
%

np   = size(p,1);  
dim  = size(p,2);
nmax = 1e6;

if (dim<2 | dim>3 | np>nmax )
    error('Problem of dimension in volsurf.m');
end

[volume,surface] = mex_volsurf(p);
